/* run embedded code-string validations */

#include <stdio.h>
#include <string.h>
#include "pyembed.h"

struct {
    int product;          /* or use a string if key is structured: */
    int quantity;         /* python code san spilt it up as needed */
    char *buyer;          /* first-initial/last */
} orders[] = {
    {111, 2, "ISpam"},    /* this would usually be an orders file */
    {222, 5, "ATest"},    /* which the python code could read too */
    {141, 3, "USpam"},
    {222, 1, "4More"},   
    {222, 0, "Stuff"},    /* the script might live in a database too */
    {131, 9, "NMore"} 
};
int numorders = 6;

run_user_validation()
{                                 /* python's initialized automaticaly */
    int i, status;                /* XXXX should check status everywhere */
    char script[4096];            /* XXXX should malloc a big-enough block */
    char *errors, *warnings;
    FILE *file;

    file = fopen("order1.py", "r");           /* customizable validations */
    fread(script, 1, 4096, file);
    status = Make_Dummy_Module("orders");     /* application's own namespace */
    for (i=0; i < numorders; i++) {
        printf("\n%d (%d, %d, '%s')\n", 
            i, orders[i].product, orders[i].quantity, orders[i].buyer);

        Set_Global("orders", "PRODUCT",  "i", orders[i].product);   /* int */
        Set_Global("orders", "QUANTITY", "i", orders[i].quantity);  /* int */
        Set_Global("orders", "BUYER",    "s", orders[i].buyer);     /* string */

        status = Run_Codestr(PY_STATEMENT, script, "orders", "", NULL);
        if (status == -1) {
            printf("Python error during validation.\n");
            PyErr_Print();  /* show traceback */
            continue;
        }

        Get_Global("orders", "ERRORS",   "s", &errors);        /* can split */
        Get_Global("orders", "WARNINGS", "s", &warnings);      /* on blanks */

        printf("errors:   %s\n", strlen(errors)? errors : "none"); 
        printf("warnings: %s\n", strlen(warnings)? warnings : "none"); 
        Run_Function("inventory", "print_files", "", NULL, "()");    
    }
}

main(int argc, char **argv)        /* C's on-top, Python's embedded */
{                                  /* but Python uses C extensions too */
    run_user_validation();         /* don't need argv in embedded code */
}

char *getprogramname() { return "order1"; }  /* or save argv[0] */
