from Tkinter import *

def frame(root, side): 
    return Frame(root, {Pack:{'side':side, 'expand':'yes', 'fill':'both'}})

def button(root, side, text, command): 
    return Button(root, {'text':text, 'command':command, 
                          Pack:{'side':side, 'expand':'yes', 'fill':'both'}})

def entry(root, side, linkvar):
    return Entry(root, {'relief':'sunken', 'textvariable':linkvar,
                         Pack:{'side':side, 'expand':'yes', 'fill':'both'}})

class CalcGui(Frame):
    def __init__(self):                                # an extended frame
        Frame.__init__(self)                           # on default top-level
        self.pack({'expand':'yes', 'fill':'both'})     # all parts expandable
        self.master.title('Python Calculator 0.1')     # 6 frames plus entry
        self.master.iconname("pcalc1")

        self.names = {}        # namespace for variables
        text = StringVar()
        entry(self, 'top', text)
        rows = ["abcd", "0123", "4567", "89()"]
        for row in rows:
            frm = frame(self, 'top')
            for char in row: button(frm, 'left', char, 
                               lambda x=text, y=char: x.set(x.get() + y))

        frm = frame(self, 'right')
        for char in "+-*/=": button(frm, 'top', char,
                               lambda x=text, y=char: x.set(x.get()+' '+y+' '))

        frm = frame(self, 'bottom')
        button(frm, 'left',  'eval',  lambda x=self, y=text: x.eval(y) )
        button(frm, 'right', 'clear', lambda x=text: x.set('') )

    def eval(self, text):
        try:
            text.set(`eval(text.get(), self.names, self.names)`)
        except SyntaxError:
            try:
                exec(text.get(), self.names, self.names)  
            except:
                text.set("ERROR")         # bad as statement too?
            else:
                text.set('')              # worked as a statement
        except:
            text.set("ERROR")             # other eval expression errors

if __name__ == '__main__': CalcGui().mainloop()

