import os
from environ import getenv, putenv      # get C module's methods

class EnvMapping:                       # wrap in a Python class
    def __setitem__(self, key, value):
        os.environ[key] = value         # on index assignment
        putenv(key, value)

    def __getitem__(self, key):
        value = getenv(key)             # on index reference
        os.environ[key] = value         # integrity check
        return value

Env = EnvMapping()                      # make one instance   
